require "json"

class JsonDB
    def initialize(file_path)
        @data_file_path = file_path
        if not File.exists?(file_path)
            @data_hash_arr = []
            save()
            puts("create empty list file #{file_path}")
        end
        @data_hash_arr = JsonDB.load(@data_file_path)
    end
    def self.load(file_path)
        File.open(file_path) do |the_file|
            JSON.parse(the_file.read())["data"]
        end
    end
    def reload()
        @data_hash_arr = JsonDB.load(@data_file_path)
    end
    def get_data()
        @data_hash_arr
    end
    def set_data(data_hash_arr)
        @data_hash_arr = data_hash_arr
    end
    def save()
        the_data = {"data"=>@data_hash_arr}
        File.open(@data_file_path,"w") do |the_file|
            the_file.write(JSON.pretty_generate(the_data))
        end
    end
end


if __FILE__ == $0
    require 'minitest/autorun'
    require 'minitest/spec'
    require 'testhelper'

    cur_dir = File.dirname(__FILE__)
    data_file_path = File.join(cur_dir,"../history_db.json")
    the_db = JsonDB.new(data_file_path)
    describe "JsonDB" do
        it "load" do
            the_db.get_data.ppt()
            # require 'pry';binding.pry
        end
        # it "add" do
        #     the_db.add({"comment"=>"test"})
        #     the_db.save()
        #     # require 'pry';binding.pry
        # end
        # it "delete" do
        #     the_db.delete_and_save(5)
        # end
        # it "edit" do
        #     the_db.edit_and_save({"comment"=>"mmm", "id"=>5})
        #     the_db.get_data.ppt()
        # end

    end
end
