require_relative 'json_db'


class KeyValueDB < JsonDB
    def initialize(file_path, max_count=999999)
        super(file_path)
        @max_count = max_count
    end
    def set_max_count(max_count)
        @max_count = max_count
    end
    def add(the_data)
        if @data_hash_arr.size >= @max_count
            @data_hash_arr.shift
        end
        new_record = the_data
        @data_hash_arr << new_record
        new_record
    end
    def add_or_update_by_key(the_data, the_key)
        found_index = -1
        @data_hash_arr.each_with_index do |cur_data, i|
            if cur_data[the_key]== the_data[the_key]
                found_index = i
                break
            end
        end
        if found_index > -1
            @data_hash_arr[found_index] = the_data
        else
            add(the_data)
        end
        the_data
    end
    def find(the_key, the_value)
        @data_hash_arr.each do |cur_data|
            if cur_data[the_key] == the_value
                return cur_data
            end
        end
        return nil
    end
    def find_all(the_key, the_value)
        @data_hash_arr.select do |cur_data|
            cur_data[the_key] == the_value
        end
    end
end

if __FILE__ == $0
    require 'minitest/autorun'
    require 'minitest/spec'
    require 'testhelper'


    cur_dir = File.dirname(__FILE__)
    data_file_path = File.join(cur_dir,"../data/confirmation_db.json")
    cc_db = KeyValueDB.new(data_file_path)

    describe "KeyValueDB" do
        it "find" do
            cc_db.find("survey_id","127.0.0.1-20170901120433934271").pt()
        end
    end
    # describe "Hash" do
    #     it "get_by_keys" do
    #         a = {"id"=>123,
    #             "config" => {
    #                 "worker_id"=>345,
    #                 "other"=>111
    #             }

    #         }
    #         a.get_by_keys(["config", "worker_id"]).pt()
    #         a.get_by_keys(["config", "mmm"]).pt()

    #     end
    # end

end
